<template>
  <q-form ref="form" @submit="onSubmit" @reset="onReset">
    <div class="row q-col-gutter-sm">
      <div class="col">
        <q-input
          outlined
          bottom-slots
          dense
          label="Nombre *"
          :rules="[val => !!val || 'Campo es requerido.']"
          v-model="draft.name"
        />
      </div>
      <div v-if="editing" class="col">
        <q-toggle
          left-label
          checked-icon="check"
          unchecked-icon="clear"
          color="green"
          label="Habilitado"
          v-model="draft.enabled"
        />
      </div>
    </div>
    <div class="q-pb-lg">
      <q-btn flat label="Limpiar" type="reset" color="primary" class="q-ml-sm"/>
      <q-btn :label="submit" type="submit" color="primary"/>
    </div>
  </q-form>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  props: ['brand', 'editing'],
  data () {
    return {
      draft: JSON.parse(JSON.stringify(this.brand))
    }
  },
  mounted () {
    this.$store.dispatch('shared/getCountries')
  },
  watch: {
    brand: function (data) {
      this.draft = JSON.parse(JSON.stringify(data))
    }
  },
  computed: {
    ...mapGetters({
      countryOptions: 'shared/countryOptions'
    }),
    submit () {
      return this.editing ? 'Actualizar' : 'Guardar'
    }
  },
  methods: {
    filterCountry (search, update) {
      update(() => {
        this.$store.commit('shared/SEARCHCOUNTRIES', search)
      })
    },
    async onSubmit () {
      await this.$refs.form.validate().then(success => {
        if (success) {
          this.$emit('save', this.draft)
        }
      })
    },
    onReset () {
      this.draft = JSON.parse(JSON.stringify(this.brand))
    }
  }
}
</script>
